/*
 * Licensed Materials - Use restricted. For use in compiling interfaces to
 * IBM Rational TestManager.
 * (c) Copyright IBM Corporation 2001,2002,2006.  All Rights Reserved.
 */

#include "stdafx.h"
#include "HelloWorldGUITestApp.h"
#include "HelloWorldGUITestAppDlg.h"

#include "HelloWorldTestDll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelloWorldGUITestAppDlg dialog

CHelloWorldGUITestAppDlg::CHelloWorldGUITestAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHelloWorldGUITestAppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHelloWorldGUITestAppDlg)
	m_StringToPass = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_CurrentStringToPass = NULL;
}

void CHelloWorldGUITestAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelloWorldGUITestAppDlg)
	DDX_Text(pDX, IDC_EDIT1, m_StringToPass);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHelloWorldGUITestAppDlg, CDialog)
	//{{AFX_MSG_MAP(CHelloWorldGUITestAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelloWorldGUITestAppDlg message handlers

BOOL CHelloWorldGUITestAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHelloWorldGUITestAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHelloWorldGUITestAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHelloWorldGUITestAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHelloWorldGUITestAppDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	char** pointerToStringToPass =  getPointerToStringToPass();

	if ( HelloWorld1( *pointerToStringToPass ) )
	{
		showSuccess( *pointerToStringToPass );
	}

	else
	{
		showFailure( *pointerToStringToPass );
	}
}

void CHelloWorldGUITestAppDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	char** pointerToStringToPass =  getPointerToStringToPass();

	if ( HelloWorld2( *pointerToStringToPass ) )
	{
		showSuccess( *pointerToStringToPass );
	}

	else
	{
		showFailure( *pointerToStringToPass );
	}
}

char** CHelloWorldGUITestAppDlg::getPointerToStringToPass()
{
	CDataExchange de( this, TRUE );
	DoDataExchange( &de );

	const char* tempString = (LPCTSTR)m_StringToPass;
	int length = strlen( tempString );

	delete [] m_CurrentStringToPass;
	m_CurrentStringToPass = new char[ length + 1 ];

    strcpy( m_CurrentStringToPass, tempString );
	return &m_CurrentStringToPass;
}

void CHelloWorldGUITestAppDlg::showSuccess( char* stringToPass )
{
	MessageBox( stringToPass, "String pass returned TRUE" );
}

void CHelloWorldGUITestAppDlg::showFailure( char* stringToPass )
{
	MessageBox( stringToPass, "String pass returned FALSE" );
}
